#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_sJIK0x0x24TN1x1x1_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=24, 
 * lda=24, ldb=24, ldc=0, mu=1, nu=1, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   #define Nb N
   const float *stM = A + (((Mb) << 4)+((Mb) << 3));
   const float *stN = B + (((Nb) << 4)+((Nb) << 3));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*1)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 1
   const int incAm = 0, incAn = -(((Mb) << 4)+((Mb) << 3));
   #define incBk 1
   const int incBm = -24, incBn = 24;
   #define incAk0 incAk
   #define incBk0 incBk
   #define incCm 1
   const int incCn = (ldc) - (Mb);
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0;
   register float m0;
   register float rC0_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         m0 = rA0 * rB0;
         rA0 = pA0[1];
         rB0 = pB0[1];

         pA0 += (incAk0);
         pB0 += (incBk0);
         for (k=22; k; k--) /* easy loop to unroll */
         {
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            pA0 += incAk;
            pB0 += incBk;
         } /* end K-loop */
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         pA0 += incAk0;
         pB0 += incBk0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
static void ATL_sJIK0x0x24TN4x1x1_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=24, 
 * lda=24, ldb=24, ldc=0, mu=4, nu=1, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M>>2)<<2;
   #define Nb N
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (((Mb) << 4)+((Mb) << 3));
   const float *stN = B + (((Nb) << 4)+((Nb) << 3));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*4*1)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 1
   const int incAm = 72, incAn = -(((Mb) << 4)+((Mb) << 3));
   #define incBk 1
   const int incBm = -24, incBn = 24;
   #define incAk0 incAk
   #define incBk0 incBk
   #define incCm 4
   const int incCn = (ldc) - (Mb);
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3;
   register float rB0;
   register float m0, m1, m2, m3;
   register float rC0_0, rC1_0, rC2_0, rC3_0;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
            rA0 = beta;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[1];
            rC1_0 *= rA0;
            rC2_0 = pC0[2];
            rC2_0 *= rA0;
            rC3_0 = pC0[3];
            rC3_0 *= rA0;
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[24];
            m0 = rA0 * rB0;
            rA2 = pA0[48];
            rA3 = pA0[72];
            m1 = rA1 * rB0;
            m2 = rA2 * rB0;
            m3 = rA3 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA0[25];
            rA2 = pA0[49];
            rA3 = pA0[73];

            pA0 += (incAk0);
            pB0 += (incBk0);
            for (k=22; k; k--) /* easy loop to unroll */
            {
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC1_0 += m1;
               m1 = rA1 * rB0;
               rC2_0 += m2;
               m2 = rA2 * rB0;
               rC3_0 += m3;
               m3 = rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA0[25];
               rA2 = pA0[49];
               rA3 = pA0[73];
               pA0 += incAk;
               pB0 += incBk;
            } /* end K-loop */
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rC1_0 += m1;
            m1 = rA1 * rB0;
            rC2_0 += m2;
            m2 = rA2 * rB0;
            rC3_0 += m3;
            m3 = rA3 * rB0;
            rC0_0 += m0;
            rC1_0 += m1;
            rC2_0 += m2;
            rC3_0 += m3;
            pA0 += incAk0;
            pB0 += incBk0;
            *pC0 = rC0_0;
            pC0[1] = rC1_0;
            pC0[2] = rC2_0;
            pC0[3] = rC3_0;
            pC0 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_sJIK0x0x24TN1x1x1_a1_bX(k, N, 24, alpha, ca + (((Mb) << 4)+((Mb) << 3)), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_sJIK0x0x24TN1x2x1_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=24, 
 * lda=24, ldb=24, ldc=0, mu=1, nu=2, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   const int Nb = (N>>1)<<1;
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (((Mb) << 4)+((Mb) << 3));
   const float *stN = B + (((Nb) << 4)+((Nb) << 3));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*2)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 1
   const int incAm = 0, incAn = -(((Mb) << 4)+((Mb) << 3));
   #define incBk 1
   const int incBm = -24, incBn = 48;
   #define incAk0 incAk
   #define incBk0 incBk
   #define incCm 1
   const int incCn = (((ldc) << 1)) - (Mb);
   float *pC0=C, *pC1=pC0+(ldc);
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0, rB1;
   register float m0, m1;
   register float rC0_0, rC0_1;
   if (pB0 != stN)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
            rA0 = beta;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC0_1 = *pC1;
            rC0_1 *= rA0;
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            rB1 = pB0[24];
            m0 = rA0 * rB0;
            m1 = rA0 * rB1;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rB1 = pB0[25];

            pA0 += (incAk0);
            pB0 += (incBk0);
            for (k=22; k; k--) /* easy loop to unroll */
            {
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rB1 = pB0[25];
               pA0 += incAk;
               pB0 += incBk;
            } /* end K-loop */
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rC0_1 += m1;
            m1 = rA0 * rB1;
            rC0_0 += m0;
            rC0_1 += m1;
            pA0 += incAk0;
            pB0 += incBk0;
            *pC0 = rC0_0;
            *pC1 = rC0_1;
            pC0 += incCm;
            pC1 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=N-Nb)
      ATL_sJIK0x0x24TN1x1x1_a1_bX(M, k, 24, alpha, ca, lda, cb + (((Nb) << 4)+((Nb) << 3)), ldb, beta, cc + (Nb*ldc), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_sJIK0x0x24TN24x24x0_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=24, 
 * lda=24, ldb=24, ldc=0, mu=4, nu=2, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M>>2)<<2;
   const int Nb = (N>>1)<<1;
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (((Mb) << 4)+((Mb) << 3));
   const float *stN = B + (((Nb) << 4)+((Nb) << 3));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*4*2)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 1
   const int incAm = 72, incAn = -(((Mb) << 4)+((Mb) << 3));
   #define incBk 1
   const int incBm = -24, incBn = 48;
   #define incAk0 incAk
   #define incBk0 incBk
   #define incCm 4
   const int incCn = (((ldc) << 1)) - (Mb);
   float *pC0=C, *pC1=pC0+(ldc);
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3;
   register float rB0, rB1;
   register float m0, m1, m2, m3;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC0_1, rC1_1, rC2_1, rC3_1;
   if (pA0 != stM)
   {
      if (pB0 != stN)
      {
         do /* N-loop */
         {
            do /* M-loop */
            {
               ATL_pfl1R(pfA);
               pfA += incPFA;
               rA0 = beta;
               rC0_0 = *pC0;
               rC0_0 *= rA0;
               rC1_0 = pC0[1];
               rC1_0 *= rA0;
               rC2_0 = pC0[2];
               rC2_0 *= rA0;
               rC3_0 = pC0[3];
               rC3_0 *= rA0;
               rC0_1 = *pC1;
               rC0_1 *= rA0;
               rC1_1 = pC1[1];
               rC1_1 *= rA0;
               rC2_1 = pC1[2];
               rC2_1 *= rA0;
               rC3_1 = pC1[3];
               rC3_1 *= rA0;
/*
 *             Start pipeline
 */
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[24];
               m0 = rA0 * rB0;
               rA2 = pA0[48];
               rA3 = pA0[72];
               rB1 = pB0[24];
               m1 = rA1 * rB0;
               m2 = rA2 * rB0;
               m3 = rA3 * rB0;

               for (k=23; k; k--) /* easy loop to unroll */
               {
                  rC0_0 += m0;
                  m0 = rA0 * rB1;
                  rC1_0 += m1;
                  m1 = rA1 * rB1;
                  rC2_0 += m2;
                  m2 = rA2 * rB1;
                  rC3_0 += m3;
                  m3 = rA3 * rB1;
                  rA0 = pA0[1];
                  rB0 = pB0[1];
                  rA1 = pA0[25];
                  rA2 = pA0[49];
                  rA3 = pA0[73];
                  rB1 = pB0[25];
                  rC0_1 += m0;
                  m0 = rA0 * rB0;
                  rC1_1 += m1;
                  m1 = rA1 * rB0;
                  rC2_1 += m2;
                  m2 = rA2 * rB0;
                  rC3_1 += m3;
                  m3 = rA3 * rB0;
                  pA0 += incAk;
                  pB0 += incBk;
               } /* end K-loop */
/*
 *             Drain pipe on last iteration of K-loop
 */
               rC0_0 += m0;
               m0 = rA0 * rB1;
               rC1_0 += m1;
               m1 = rA1 * rB1;
               rC2_0 += m2;
               m2 = rA2 * rB1;
               rC3_0 += m3;
               m3 = rA3 * rB1;
               rC0_1 += m0;
               rC1_1 += m1;
               rC2_1 += m2;
               rC3_1 += m3;
               pA0 += incAk0;
               pB0 += incBk0;
               *pC0 = rC0_0;
               pC0[1] = rC1_0;
               pC0[2] = rC2_0;
               pC0[3] = rC3_0;
               *pC1 = rC0_1;
               pC1[1] = rC1_1;
               pC1[2] = rC2_1;
               pC1[3] = rC3_1;
               pC0 += incCm;
               pC1 += incCm;
               pA0 += incAm;
               pB0 += incBm;
            }
            while(pA0 != stM);
            pC0 += incCn;
            pC1 += incCn;
            pA0 += incAn;
            pB0 += incBn;
         }
         while(pB0 != stN);
      }
   }
   if (k=N-Nb)
      ATL_sJIK0x0x24TN4x1x1_a1_bX(M, k, 24, alpha, ca, lda, cb + (((Nb) << 4)+((Nb) << 3)), ldb, beta, cc + (Nb*ldc), ldc);
   if (Nb && (k=M-Mb))
      ATL_sJIK0x0x24TN1x2x1_a1_bX(k, Nb, 24, alpha, ca + (((Mb) << 4)+((Mb) << 3)), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
