#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_sJIK0x0x0TN1x1x4_aX_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=1, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   #define Nb N
   const int Kb = (K>>2)<<2;
   const float *stM = A + (lda*Mb);
   const float *stN = B + (ldb*Nb);
   const float *pfA = A + M;
   const float BetaAlpha = beta / alpha;
   #define incAk 4
   const int incAm = ((lda) - Kb), incAn = -(Mb*lda);
   #define incBk 4
   const int incBm = -(Kb), incBn = (ldb);
   #define incCm 1
   const int incCn = (ldc) - (Mb);
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0;
   register float rC0_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+64);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         for (k=Kb; k; k -= 4) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         switch(k = (K-Kb))
         {
         case 1:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            break;
         case 2:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += rA0 * rB0;
            break;
         case 3:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            break;
         case 0: ;
         }
         rB0 = alpha;
         rC0_0 *= rB0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
static void ATL_sJIK0x0x0TN4x1x4_aX_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=4, nu=1, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M>>2)<<2;
   #define Nb N
   const int Kb = (K>>2)<<2;
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (lda*Mb);
   const float *stN = B + (ldb*Nb);
   const float *pfA = A + M;
   const float BetaAlpha = beta / alpha;
   #define incAk 4
   const int incAm = ((((lda) << 2)) - Kb), incAn = -(Mb*lda);
   #define incBk 4
   const int incBm = -(Kb), incBn = (ldb);
   #define incCm 4
   const int incCn = (ldc) - (Mb);
   float *pC0=C;
   const float *pA0=A, *pA1=pA0+(lda), *pA2=pA1+(lda), *pA3=pA2+(lda);
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3;
   register float rB0;
   register float rC0_0, rC1_0, rC2_0, rC3_0;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         ATL_pfl1R(pfA+0);
         ATL_pfl1R(pfA+64);
         pfA += lda;
         do /* M-loop */
         {
            rA0 = BetaAlpha;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[1];
            rC1_0 *= rA0;
            rC2_0 = pC0[2];
            rC2_0 *= rA0;
            rC3_0 = pC0[3];
            rC3_0 *= rA0;
            for (k=Kb; k; k -= 4) /* easy loop to unroll */
            {
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rA2 = *pA2;
               rA3 = *pA3;
               rC0_0 += rA0 * rB0;
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rA3 = pA3[1];
               rC0_0 += rA0 * rB0;
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rC0_0 += rA0 * rB0;
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rA3 = pA3[3];
               rC0_0 += rA0 * rB0;
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               pA0 += incAk;
               pA1 += incAk;
               pA2 += incAk;
               pA3 += incAk;
               pB0 += incBk;
            }
            switch(k = (K-Kb))
            {
            case 1:
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rA2 = *pA2;
               rA3 = *pA3;
               rC0_0 += rA0 * rB0;
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               break;
            case 2:
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rA2 = *pA2;
               rA3 = *pA3;
               rC0_0 += rA0 * rB0;
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rA3 = pA3[1];
               rC0_0 += rA0 * rB0;
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               break;
            case 3:
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rA2 = *pA2;
               rA3 = *pA3;
               rC0_0 += rA0 * rB0;
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rA3 = pA3[1];
               rC0_0 += rA0 * rB0;
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rC0_0 += rA0 * rB0;
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               break;
            case 0: ;
            }
            rB0 = alpha;
            rC0_0 *= rB0;
            rC1_0 *= rB0;
            rC2_0 *= rB0;
            rC3_0 *= rB0;
            *pC0 = rC0_0;
            pC0[1] = rC1_0;
            pC0[2] = rC2_0;
            pC0[3] = rC3_0;
            pC0 += incCm;
            pA0 += incAm;
            pA1 += incAm;
            pA2 += incAm;
            pA3 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pA0 += incAn;
         pA1 += incAn;
         pA2 += incAn;
         pA3 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_sJIK0x0x0TN1x1x4_aX_bX(k, N, K, alpha, ca + (Mb*lda), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_sJIK0x0x0TN1x3x4_aX_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=3, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   const int Nb = (N/3)*3;
   const int Kb = (K>>2)<<2;
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (lda*Mb);
   const float *stN = B + (ldb*Nb);
   const float *pfA = A + M;
   const float BetaAlpha = beta / alpha;
   #define incAk 4
   const int incAm = ((lda) - Kb), incAn = -(Mb*lda);
   #define incBk 4
   const int incBm = -(Kb), incBn = (((ldb) << 1)+ldb);
   #define incCm 1
   const int incCn = (((ldc) << 1)+ldc) - (Mb);
   float *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc);
   const float *pA0=A;
   const float *pB0=B, *pB1=pB0+(ldb), *pB2=pB1+(ldb);
   register int k;
   register float rA0;
   register float rB0, rB1, rB2;
   register float rC0_0, rC0_1, rC0_2;
   if (pB0 != stN)
   {
      do /* N-loop */
      {
         ATL_pfl1R(pfA+0);
         ATL_pfl1R(pfA+64);
         pfA += lda;
         do /* M-loop */
         {
            rA0 = BetaAlpha;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC0_1 = *pC1;
            rC0_1 *= rA0;
            rC0_2 = *pC2;
            rC0_2 *= rA0;
            for (k=Kb; k; k -= 4) /* easy loop to unroll */
            {
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = *pB1;
               rB2 = *pB2;
               rC0_0 += rA0 * rB0;
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rB1 = pB1[1];
               rB2 = pB2[1];
               rC0_0 += rA0 * rB0;
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rB1 = pB1[2];
               rB2 = pB2[2];
               rC0_0 += rA0 * rB0;
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rB1 = pB1[3];
               rB2 = pB2[3];
               rC0_0 += rA0 * rB0;
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               pA0 += incAk;
               pB0 += incBk;
               pB1 += incBk;
               pB2 += incBk;
            }
            switch(k = (K-Kb))
            {
            case 1:
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = *pB1;
               rB2 = *pB2;
               rC0_0 += rA0 * rB0;
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               break;
            case 2:
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = *pB1;
               rB2 = *pB2;
               rC0_0 += rA0 * rB0;
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rB1 = pB1[1];
               rB2 = pB2[1];
               rC0_0 += rA0 * rB0;
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               break;
            case 3:
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = *pB1;
               rB2 = *pB2;
               rC0_0 += rA0 * rB0;
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rB1 = pB1[1];
               rB2 = pB2[1];
               rC0_0 += rA0 * rB0;
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rB1 = pB1[2];
               rB2 = pB2[2];
               rC0_0 += rA0 * rB0;
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               break;
            case 0: ;
            }
            rB0 = alpha;
            rC0_0 *= rB0;
            rC0_1 *= rB0;
            rC0_2 *= rB0;
            *pC0 = rC0_0;
            *pC1 = rC0_1;
            *pC2 = rC0_2;
            pC0 += incCm;
            pC1 += incCm;
            pC2 += incCm;
            pA0 += incAm;
            pB0 += incBm;
            pB1 += incBm;
            pB2 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pC2 += incCn;
         pA0 += incAn;
         pB0 += incBn;
         pB1 += incBn;
         pB2 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=N-Nb)
      ATL_sJIK0x0x0TN1x1x4_aX_bX(M, k, K, alpha, ca, lda, cb + (Nb*ldb), ldb, beta, cc + (Nb*ldc), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_sJIK0x0x0TN0x0x0_aX_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=4, nu=3, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M>>2)<<2;
   const int Nb = (N/3)*3;
   const int Kb = (K>>2)<<2;
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (lda*Mb);
   const float *stN = B + (ldb*Nb);
   const float *pfA = A + M;
   const float BetaAlpha = beta / alpha;
   #define incAk 4
   const int incAm = ((((lda) << 2)) - Kb), incAn = -(Mb*lda);
   #define incBk 4
   const int incBm = -(Kb), incBn = (((ldb) << 1)+ldb);
   #define incCm 4
   const int incCn = (((ldc) << 1)+ldc) - (Mb);
   float *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc);
   const float *pA0=A, *pA1=pA0+(lda), *pA2=pA1+(lda), *pA3=pA2+(lda);
   const float *pB0=B, *pB1=pB0+(ldb), *pB2=pB1+(ldb);
   register int k;
   register float rA0, rA1, rA2, rA3;
   register float rB0, rB1, rB2;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC0_1, rC1_1, rC2_1, rC3_1, rC0_2, rC1_2, rC2_2, rC3_2;
   if (pA0 != stM)
   {
      if (pB0 != stN)
      {
         do /* N-loop */
         {
            ATL_pfl1R(pfA+0);
            ATL_pfl1R(pfA+64);
            pfA += lda;
            do /* M-loop */
            {
               rA0 = BetaAlpha;
               rC0_0 = *pC0;
               rC0_0 *= rA0;
               rC1_0 = pC0[1];
               rC1_0 *= rA0;
               rC2_0 = pC0[2];
               rC2_0 *= rA0;
               rC3_0 = pC0[3];
               rC3_0 *= rA0;
               rC0_1 = *pC1;
               rC0_1 *= rA0;
               rC1_1 = pC1[1];
               rC1_1 *= rA0;
               rC2_1 = pC1[2];
               rC2_1 *= rA0;
               rC3_1 = pC1[3];
               rC3_1 *= rA0;
               rC0_2 = *pC2;
               rC0_2 *= rA0;
               rC1_2 = pC2[1];
               rC1_2 *= rA0;
               rC2_2 = pC2[2];
               rC2_2 *= rA0;
               rC3_2 = pC2[3];
               rC3_2 *= rA0;
               for (k=Kb; k; k -= 4) /* easy loop to unroll */
               {
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = *pA1;
                  rA2 = *pA2;
                  rA3 = *pA3;
                  rC0_0 += rA0 * rB0;
                  rB1 = *pB1;
                  rB2 = *pB2;
                  rC1_0 += rA1 * rB0;
                  rC2_0 += rA2 * rB0;
                  rC3_0 += rA3 * rB0;
                  rC0_1 += rA0 * rB1;
                  rC1_1 += rA1 * rB1;
                  rC2_1 += rA2 * rB1;
                  rC3_1 += rA3 * rB1;
                  rC0_2 += rA0 * rB2;
                  rC1_2 += rA1 * rB2;
                  rC2_2 += rA2 * rB2;
                  rC3_2 += rA3 * rB2;
                  rA0 = pA0[1];
                  rB0 = pB0[1];
                  rA1 = pA1[1];
                  rA2 = pA2[1];
                  rA3 = pA3[1];
                  rC0_0 += rA0 * rB0;
                  rB1 = pB1[1];
                  rB2 = pB2[1];
                  rC1_0 += rA1 * rB0;
                  rC2_0 += rA2 * rB0;
                  rC3_0 += rA3 * rB0;
                  rC0_1 += rA0 * rB1;
                  rC1_1 += rA1 * rB1;
                  rC2_1 += rA2 * rB1;
                  rC3_1 += rA3 * rB1;
                  rC0_2 += rA0 * rB2;
                  rC1_2 += rA1 * rB2;
                  rC2_2 += rA2 * rB2;
                  rC3_2 += rA3 * rB2;
                  rA0 = pA0[2];
                  rB0 = pB0[2];
                  rA1 = pA1[2];
                  rA2 = pA2[2];
                  rA3 = pA3[2];
                  rC0_0 += rA0 * rB0;
                  rB1 = pB1[2];
                  rB2 = pB2[2];
                  rC1_0 += rA1 * rB0;
                  rC2_0 += rA2 * rB0;
                  rC3_0 += rA3 * rB0;
                  rC0_1 += rA0 * rB1;
                  rC1_1 += rA1 * rB1;
                  rC2_1 += rA2 * rB1;
                  rC3_1 += rA3 * rB1;
                  rC0_2 += rA0 * rB2;
                  rC1_2 += rA1 * rB2;
                  rC2_2 += rA2 * rB2;
                  rC3_2 += rA3 * rB2;
                  rA0 = pA0[3];
                  rB0 = pB0[3];
                  rA1 = pA1[3];
                  rA2 = pA2[3];
                  rA3 = pA3[3];
                  rC0_0 += rA0 * rB0;
                  rB1 = pB1[3];
                  rB2 = pB2[3];
                  rC1_0 += rA1 * rB0;
                  rC2_0 += rA2 * rB0;
                  rC3_0 += rA3 * rB0;
                  rC0_1 += rA0 * rB1;
                  rC1_1 += rA1 * rB1;
                  rC2_1 += rA2 * rB1;
                  rC3_1 += rA3 * rB1;
                  rC0_2 += rA0 * rB2;
                  rC1_2 += rA1 * rB2;
                  rC2_2 += rA2 * rB2;
                  rC3_2 += rA3 * rB2;
                  pA0 += incAk;
                  pA1 += incAk;
                  pA2 += incAk;
                  pA3 += incAk;
                  pB0 += incBk;
                  pB1 += incBk;
                  pB2 += incBk;
               }
               switch(k = (K-Kb))
               {
               case 1:
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = *pA1;
                  rA2 = *pA2;
                  rA3 = *pA3;
                  rC0_0 += rA0 * rB0;
                  rB1 = *pB1;
                  rB2 = *pB2;
                  rC1_0 += rA1 * rB0;
                  rC2_0 += rA2 * rB0;
                  rC3_0 += rA3 * rB0;
                  rC0_1 += rA0 * rB1;
                  rC1_1 += rA1 * rB1;
                  rC2_1 += rA2 * rB1;
                  rC3_1 += rA3 * rB1;
                  rC0_2 += rA0 * rB2;
                  rC1_2 += rA1 * rB2;
                  rC2_2 += rA2 * rB2;
                  rC3_2 += rA3 * rB2;
                  break;
               case 2:
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = *pA1;
                  rA2 = *pA2;
                  rA3 = *pA3;
                  rC0_0 += rA0 * rB0;
                  rB1 = *pB1;
                  rB2 = *pB2;
                  rC1_0 += rA1 * rB0;
                  rC2_0 += rA2 * rB0;
                  rC3_0 += rA3 * rB0;
                  rC0_1 += rA0 * rB1;
                  rC1_1 += rA1 * rB1;
                  rC2_1 += rA2 * rB1;
                  rC3_1 += rA3 * rB1;
                  rC0_2 += rA0 * rB2;
                  rC1_2 += rA1 * rB2;
                  rC2_2 += rA2 * rB2;
                  rC3_2 += rA3 * rB2;
                  rA0 = pA0[1];
                  rB0 = pB0[1];
                  rA1 = pA1[1];
                  rA2 = pA2[1];
                  rA3 = pA3[1];
                  rC0_0 += rA0 * rB0;
                  rB1 = pB1[1];
                  rB2 = pB2[1];
                  rC1_0 += rA1 * rB0;
                  rC2_0 += rA2 * rB0;
                  rC3_0 += rA3 * rB0;
                  rC0_1 += rA0 * rB1;
                  rC1_1 += rA1 * rB1;
                  rC2_1 += rA2 * rB1;
                  rC3_1 += rA3 * rB1;
                  rC0_2 += rA0 * rB2;
                  rC1_2 += rA1 * rB2;
                  rC2_2 += rA2 * rB2;
                  rC3_2 += rA3 * rB2;
                  break;
               case 3:
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = *pA1;
                  rA2 = *pA2;
                  rA3 = *pA3;
                  rC0_0 += rA0 * rB0;
                  rB1 = *pB1;
                  rB2 = *pB2;
                  rC1_0 += rA1 * rB0;
                  rC2_0 += rA2 * rB0;
                  rC3_0 += rA3 * rB0;
                  rC0_1 += rA0 * rB1;
                  rC1_1 += rA1 * rB1;
                  rC2_1 += rA2 * rB1;
                  rC3_1 += rA3 * rB1;
                  rC0_2 += rA0 * rB2;
                  rC1_2 += rA1 * rB2;
                  rC2_2 += rA2 * rB2;
                  rC3_2 += rA3 * rB2;
                  rA0 = pA0[1];
                  rB0 = pB0[1];
                  rA1 = pA1[1];
                  rA2 = pA2[1];
                  rA3 = pA3[1];
                  rC0_0 += rA0 * rB0;
                  rB1 = pB1[1];
                  rB2 = pB2[1];
                  rC1_0 += rA1 * rB0;
                  rC2_0 += rA2 * rB0;
                  rC3_0 += rA3 * rB0;
                  rC0_1 += rA0 * rB1;
                  rC1_1 += rA1 * rB1;
                  rC2_1 += rA2 * rB1;
                  rC3_1 += rA3 * rB1;
                  rC0_2 += rA0 * rB2;
                  rC1_2 += rA1 * rB2;
                  rC2_2 += rA2 * rB2;
                  rC3_2 += rA3 * rB2;
                  rA0 = pA0[2];
                  rB0 = pB0[2];
                  rA1 = pA1[2];
                  rA2 = pA2[2];
                  rA3 = pA3[2];
                  rC0_0 += rA0 * rB0;
                  rB1 = pB1[2];
                  rB2 = pB2[2];
                  rC1_0 += rA1 * rB0;
                  rC2_0 += rA2 * rB0;
                  rC3_0 += rA3 * rB0;
                  rC0_1 += rA0 * rB1;
                  rC1_1 += rA1 * rB1;
                  rC2_1 += rA2 * rB1;
                  rC3_1 += rA3 * rB1;
                  rC0_2 += rA0 * rB2;
                  rC1_2 += rA1 * rB2;
                  rC2_2 += rA2 * rB2;
                  rC3_2 += rA3 * rB2;
                  break;
               case 0: ;
               }
               rB0 = alpha;
               rC0_0 *= rB0;
               rC0_1 *= rB0;
               rC0_2 *= rB0;
               rC1_0 *= rB0;
               rC1_1 *= rB0;
               rC1_2 *= rB0;
               rC2_0 *= rB0;
               rC2_1 *= rB0;
               rC2_2 *= rB0;
               rC3_0 *= rB0;
               rC3_1 *= rB0;
               rC3_2 *= rB0;
               *pC0 = rC0_0;
               pC0[1] = rC1_0;
               pC0[2] = rC2_0;
               pC0[3] = rC3_0;
               *pC1 = rC0_1;
               pC1[1] = rC1_1;
               pC1[2] = rC2_1;
               pC1[3] = rC3_1;
               *pC2 = rC0_2;
               pC2[1] = rC1_2;
               pC2[2] = rC2_2;
               pC2[3] = rC3_2;
               pC0 += incCm;
               pC1 += incCm;
               pC2 += incCm;
               pA0 += incAm;
               pA1 += incAm;
               pA2 += incAm;
               pA3 += incAm;
               pB0 += incBm;
               pB1 += incBm;
               pB2 += incBm;
            }
            while(pA0 != stM);
            pC0 += incCn;
            pC1 += incCn;
            pC2 += incCn;
            pA0 += incAn;
            pA1 += incAn;
            pA2 += incAn;
            pA3 += incAn;
            pB0 += incBn;
            pB1 += incBn;
            pB2 += incBn;
         }
         while(pB0 != stN);
      }
   }
   if (k=N-Nb)
      ATL_sJIK0x0x0TN4x1x4_aX_bX(M, k, K, alpha, ca, lda, cb + (Nb*ldb), ldb, beta, cc + (Nb*ldc), ldc);
   if (Nb && (k=M-Mb))
      ATL_sJIK0x0x0TN1x3x4_aX_bX(k, Nb, K, alpha, ca + (Mb*lda), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
